# scaricatore

![version](https://git.pweapon.org/odo/dl.emersa.it/badges/release.svg 'version')
![status](https://git.pweapon.org/odo/dl.emersa.it/badges/workflows/ci.yaml/badge.svg 'status')

<img src='./static/screen.webp' alt='screen' height=300>

It's a svelte(kit) frontend that uses `yt-dlp` to let the user download things from the web.

## How to Deploy

### using node

- Install nodejs (if on debian, use `extrepo` for adding the official nodesource repository)
- Create a new directory (`"${PROJECT_ROOT}"`)
- run `scripts/install.sh "${PROJECT_ROOT}"`

Edit `scripts/deploy_example.sh` if you need to deploy `dl.emersa.it` to some server using `SSH`.

### Docker

(currently not supported)

## Development: getting started

- Clone the repo
- Run `npm install` (you have to have node installed)
- Run `npm run download-yt-dlp`
- Copy `.env.example` to `.env`
- Change `.env` to set `YTDLP_PATH` to the yt-dlp binary previously downloaded
- Run `npm run dev`
- Now you can write code

## To do:

- Proper logs (I don't like them, not useful for production build)
- Containerfile for container build
- Source spotify (spotdl)
- Parse URL info without `youtube-dl-exec`
- Dockerfile inside the forgejo release action
